# Services
服务组件都位于 `src/services` 目录.

## AlbumCoverCache
主要用于处理歌曲封面的缓存.

## AutoStart
支持自动启动. 就是将 desktop 文件放在 `~/.config/autostart/` 目录.

## DBusManager
用于管理几个 dbus 接口服务, 它并不定义具体的 dbus 接口.

## DefaultClient
支持是否将云音乐设置为默认的音乐播放器. 就是修改 `~/.local/share/mimetypes/mimeapps.list`
文件.

## DownloadManager
用于支持歌曲批量下载功能. 它工作在后台线程, 具体的下载操作是由 DownloadWorker 来完成的.

## FeedbackManager
用于支持上传日志文件的功能. 将本地日志文件打包压缩, 然后上传至服务器, 同时还会上传本机的
基本系统信息.

## Keybinder
用于支持快捷键的绑定功能, 全局快捷键使用的是 `QAbstractNativeEventFilter` 的接口.

## LocalMusicManager
支持本地音乐管理的功能, 主要是扫描本地音乐目录, 解析音频文件的 metadata, 然后写入数据库.
同时会递归监听本地音乐目录的变化.

## LogManager
用于管理日志的重定向以及存储.

## MediaPlayer
音乐播放器, 类似于 `QMediaPlayer` 的接口. 目前使用的后端是 libvlc.

## PopupMenuManager
用于支持全局右键菜单, 解析前端页面传回来的 json 对象, 然后构建相应的 QMenu.

## ResourcesManager
查询系统资源的接口,  比如列举中文字体, 获取系统版本号等.

## SettingsManager
包装了 QSettings.

## SignalManager
代理中转一些全局信号

## SkinManager
支持换肤的功能, 切换新的皮肤后, 要返回新的 css 资源文件, 同时修改 mini 播放器里用到的 svg 图片.

## StorageManager
本地文件操作相关的接口, 比如移动目录.

## SystemTrayIcon
系统托盘. 这个在 Ubuntu Unity 桌面环境有些问题.
