// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef APPLICATION_H_
#define APPLICATION_H_

#include <QApplication>

namespace netease {

class AlbumCoverCache;
class DBusManager;
class DownloadManager;
class FeedbackManager;
class Keybinder;
class LocalMusicManager;
class LogManager;
class LrcManager;
class MediaMetadata;
class MediaPlayer;
class MediaPlayerCache;
class PopupMenuManager;
class ProcessManager;
class SignalManager;
class SkinManager;
class StorageManager;
class SystemTrayIcon;
class ThreadManager;
class UrlManager;

class DesktopLyrics;
class MiniPlayer;
class WindowManager;

class Application : public QApplication {
 Q_OBJECT

 public:
  Application(int& argc, char** argv);

  ~Application() override;

  void initChildren();

  AlbumCoverCache* album_cover_cache = nullptr;
  DBusManager* dbus_manager = nullptr;
  DownloadManager* download_manager = nullptr;
  FeedbackManager* feedback_manager = nullptr;
  Keybinder* keybinder = nullptr;
  LocalMusicManager* local_music_manager = nullptr;
  LogManager* log_manager = nullptr;
  LrcManager* lrc_manager = nullptr;
  MediaMetadata* media_metadata = nullptr;
  MediaPlayer* media_player = nullptr;
  MediaPlayerCache* media_player_cache = nullptr;
  PopupMenuManager* popup_menu_manager = nullptr;
  ProcessManager* process_manager = nullptr;
  SignalManager* signal_manager = nullptr;
  SkinManager* skin_manager = nullptr;
  StorageManager* storage_manager = nullptr;
  SystemTrayIcon* system_tray_icon = nullptr;
  ThreadManager* thread_manager = nullptr;
  UrlManager* url_manager = nullptr;

  WindowManager* window_manager = nullptr;
  DesktopLyrics* desktop_lyrics = nullptr;
  MiniPlayer* mini_player = nullptr;

 public slots:
  void quitApplication();

 private:
  void setI18n();
};

}  // namespace netease

extern netease::Application* app;

#endif  // APPLICATION_H_
