/*
 * Copyright (C) 2017 ~ 2017 Deepin Technology Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "base/consts.h"

namespace netease {

// Name of application.
// This name can be used as folder name, like in /usr/share or /usr/lib.
const char kAppName[] = "netease-cloud-music";

// Human readable name of application.
const char kAppDisplayName[] = "Cloud Music";

// Human readable version.
const char kAppVersion[] = "1.2.0";

// Build id.
const char kAppBuildId[] = "0408";

// Name of linux .desktop file.
const char kAppDesktopFile[] = "netease-cloud-music.desktop";

// Name of application configuration file.
const char kAppSettingsFile[] = "netease-cloud-music.ini";

// Folder name to store downloaded music resources.
// That is $HOME/Music/CloudMusic.
const char kDefaultMusicDownloadDirName[] = "CloudMusic";

// Folder name of HTML5 localStorage.
// That is $HOME/.cache/cloud-music/WebkitLocalStorage/.
const char kLocalStorageDirName[] = "WebkitLocalStorage";

const char kCefDirName[] = "Cef";

// To store media information of local music resources.
// And that is $HOME/.cache/cloud-music/OfflineLibrary.db
// This file is the same as Library/library.dat on Windows platform.
const char kOfflineDB[] = "OfflineLibrary.db";

// Folder name of local cached music.
// When playing online music, that media is cached in MusicCache/.
// That is $HOME/.cache/cloud-music/MusicCache/.
const char kMusicCacheDirName[] = "MusicCache";

// Folder name of qtwebkit cache.
// That is $HOME/.cache/cloud-music/NetworkCache/.
const char kNetworkDiskCacheDirName[] = "NetworkCache";

// File name of online metadata database.
// And that is $HOME/.cache/cloud-music/OnlineLibrary.db.
// This file is the same as Library/webdata.dat on Windows platform.
const char kOnlineDB[] = "OnlineLibrary.db";

// Folder name of storage cache.
// That is $HOME/.cache/cloud-music/StorageCache/.
const char kStorageCacheDirName[] = "StorageCache";

// Scheme name of orpheus.
const char kSchemeOrpheus[] = "orpheus";

// Process startup argument list.
const char kArgsMoveRun[] = "--orpheus-startup=moverun";
const char kArgsInstall[] = "--orpheus-startup=install";
const char kArgsQuitRun[] = "--orpheus-startup=quitrun";
const char kArgsRestart[] = "--orpheus-startup=restart";
const char kArgsOrpheus[] = "--orpheus";
const char kArgsMoveRunSrc[] = "--movesrc=";
const char kArgsMoveRunDst[] = "--movedest=";
const char kArgsRequire[] = "--require=";

const char kArgsOrpheusStartupName[] = "orpheus-startup";
const char kArgsMoveRunSrcName[] = "movesrc";
const char kArgsMoveRunDstName[] = "movedest";
const char kArgsRequireName[] = "require";
const char kArgsWebArgumentName[] = "webargument";

// Page to be loaded in main webview window.
//#ifndef N_DEBUG
//const char kIndexPage[] = "qrc:/webapp/src/html/start.html";
//#else
const char kIndexPage[] = "qrc:/webapp/pub/start.html";
//#endif
//const char kIndexPage[] = "orpheus://orpheus/src/html/start.html";

}  // namespace netease
