// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef BASE_CONSTS_H_
#define BASE_CONSTS_H_

namespace netease {

// Name of application.
// This name can be used as folder name, like in /usr/share or /usr/lib.
extern const char kAppName[];

// Human readable name of application.
extern const char kAppDisplayName[];

// Human readable version.
extern const char kAppVersion[];

// Build id.
extern const char kAppBuildId[];

// Name of linux .desktop file.
extern const char kAppDesktopFile[];

// Name of application configuration file.
extern const char kAppSettingsFile[];

// Folder name to store downloaded music resources.
// That is $HOME/Music/CloudMusic.
extern const char kDefaultMusicDownloadDirName[];

// Folder name of HTML5 localStorage.
// That is $HOME/.cache/cloud-music/WebkitLocalStorage/.
extern const char kLocalStorageDirName[];

extern const char kCefDirName[];

// To store media information of local music resources.
// And that is $HOME/.cache/cloud-music/OfflineLibrary.db
// This file is the same as Library/library.dat on Windows platform.
extern const char kOfflineDB[];

// Folder name of local cached music.
// When playing online music, that media is cached in MusicCache/.
// That is $HOME/.cache/cloud-music/MusicCache/.
extern const char kMusicCacheDirName[];

// Folder name of qtwebkit cache.
// That is $HOME/.cache/cloud-music/NetworkCache/.
extern const char kNetworkDiskCacheDirName[];

// File name of online metadata database.
// And that is $HOME/.cache/cloud-music/OnlineLibrary.db.
// This file is the same as Library/webdata.dat on Windows platform.
extern const char kOnlineDB[];

// Folder name of storage cache.
// That is $HOME/.cache/cloud-music/StorageCache/.
extern const char kStorageCacheDirName[];

// Scheme name of orpheus.
extern const char kSchemeOrpheus[];

// Process startup argument list.
extern const char kArgsMoveRun[];
extern const char kArgsInstall[];
extern const char kArgsQuitRun[];
extern const char kArgsRestart[];
extern const char kArgsOrpheus[];
extern const char kArgsMoveRunSrc[];
extern const char kArgsMoveRunDst[];
extern const char kArgsRequire[];

extern const char kArgsOrpheusStartupName[];
extern const char kArgsMoveRunSrcName[];
extern const char kArgsMoveRunDstName[];
extern const char kArgsRequireName[];
extern const char kArgsWebArgumentName[];

// Page to be loaded in main webview window.
extern const char kIndexPage[];

}  // namespace netease

#endif  // BASE_CONSTS_H_
