/*
 * Copyright (C) 2017 ~ 2017 Deepin Technology Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CLOUD_MUSIC_BASE_PROCESS_UTIL_H
#define CLOUD_MUSIC_BASE_PROCESS_UTIL_H

#include <QVector>

namespace netease {

// Returns a list of process id whose ancestor process id is |parent|.
QVector<pid_t> GetChildProcesses(pid_t parent);

// Kill all child processes whose ancestor process id is |parent|.
void KillChildProcesses(pid_t parent, bool include_self);

// Kill all child processes including self.
void KillAllProcesses();

}  // namespace netease

#endif  // CLOUD_MUSIC_BASE_PROCESS_UTIL_H
