// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#include "channel/channel.h"

namespace netease {

Channel::Channel(WebView* webview) : QObject() {
  this->setObjectName("channel");

  app = new App(this);
  audioplayer = new AudioPlayer(this);
  browser = new Browser(this);
  download = new Download(this);
  musiclibrary = new MusicLibrary(this);
  os = new OS(this);
  player = new Player(this);
  storage = new Storage(this);
  trayicon = new TrayIcon(this);
  update = new Update(this);

  // Pass MainWindow to winhelper.
  winhelper = new WinHelper(this, webview);
}

}  // namespace netease
