// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef CHANNEL_CHANNEL_H_
#define CHANNEL_CHANNEL_H_

#include <QObject>

#include "native/app.h"
#include "native/audio_player.h"
#include "native/browser.h"
#include "native/download.h"
#include "native/music_library.h"
#include "native/os.h"
#include "native/player.h"
#include "native/storage.h"
#include "native/tray_icon.h"
#include "native/update.h"
#include "native/win_helper.h"
#include "ui/views/web_view.h"

namespace netease {

class WebView;

// Channel object exposed to global context of webview as "_channel".
// TODO(xushaohua): Make this class singleton.
class Channel : public QObject {
  Q_OBJECT

  Q_PROPERTY(App* app MEMBER app CONSTANT)
  Q_PROPERTY(AudioPlayer* audioplayer MEMBER audioplayer CONSTANT)
  Q_PROPERTY(Browser* browser MEMBER browser CONSTANT)
  Q_PROPERTY(Download* download MEMBER download CONSTANT)
  Q_PROPERTY(MusicLibrary* musiclibrary MEMBER musiclibrary CONSTANT)
  Q_PROPERTY(OS* os MEMBER os CONSTANT)
  Q_PROPERTY(Player* player MEMBER player CONSTANT)
  Q_PROPERTY(Storage* storage MEMBER storage CONSTANT)
  Q_PROPERTY(TrayIcon* trayicon MEMBER trayicon CONSTANT)
  Q_PROPERTY(Update* update MEMBER update CONSTANT)
  Q_PROPERTY(WinHelper* winhelper MEMBER winhelper CONSTANT)
 public:
  explicit Channel(WebView* webview);

  // App instance.
  App* app;
  AudioPlayer* audioplayer;
  Browser* browser;
  Download* download;
  MusicLibrary* musiclibrary;
  OS* os;
  Player* player;
  Storage* storage;
  TrayIcon* trayicon;
  Update* update;
  WinHelper* winhelper;
};

}  // namespace netease

#endif  // CHANNEL_CHANNEL_H_
