// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef DBUS_NETWORK_MANAGER_INTERFACE_H_
#define DBUS_NETWORK_MANAGER_INTERFACE_H_

#include <QtCore/QObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>
#include <QtDBus/QtDBus>

class NetworkManagerInterface: public QDBusAbstractInterface {
  Q_OBJECT
 public:
  explicit NetworkManagerInterface(QObject* parent = 0);
  ~NetworkManagerInterface();

 signals:
  void StateChanged(uint state);

 public slots:
  inline QDBusPendingReply<uint> CheckConnectivity() {
    return asyncCall(QStringLiteral("CheckConnectivity"));
  }

  inline QDBusPendingReply<uint> state() {
    return asyncCall(QStringLiteral("state"));
  }
};

#endif  // DBUS_NETWORK_MANAGER_INTERFACE_H_