// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#include "native/download.h"

#include <QDebug>

#include "application.h"
#include "service/download_manager.h"

namespace netease {

Download::Download(QObject* parent) : QObject(parent) {
  this->setObjectName("download");

  this->initConnections();
}

void Download::cancel(const QString& task_id) {
  emit app->download_manager->cancel(task_id);
}

void Download::initConnections() {
  connect(app->download_manager, &DownloadManager::onCanceled,
          this, &Download::oncancel);
  connect(app->download_manager, &DownloadManager::onProcess,
          this, &Download::onprocess);
  connect(app->download_manager, &DownloadManager::onQueryDownloadSchedule,
          this, &Download::ondownloadeshecdule);
}

void Download::pause(const QString& task_id) {
  emit app->download_manager->pause(task_id);
}

void Download::queryDownloadShecdule(const QVariantList& task_list) {
  emit app->download_manager->queryDownloadSchedule(task_list);
}

void Download::start(const QVariantMap& task_info) {
  emit app->download_manager->download(task_info);
}

}  // namespace netease
