// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#include "native/update.h"

#include <QDebug>

#include "base/consts.h"

namespace netease {

Update::Update(QObject* parent) : QObject(parent) {
  this->setObjectName("update");
}

QString Update::getVersion(const QString& module) const {
  Q_UNUSED(module);
  return QString(kAppVersion).append(".").append(kAppBuildId);
}

QVariantMap Update::getVisualVersion() const {
  QVariantMap result;
  result.insert("version", QString(kAppVersion));
  result.insert("build", QString(kAppBuildId));
  return result;
}

void Update::startUpdate(const QVariantList& update_info) {
  qDebug() << "TODO [Update]::startUpdate()" << update_info;
}

}  // namespace netease
