#!/usr/bin/env python3

# Update QRC file of webapp

import os
import sys

def generate(prefix, folders, output):
    with open(output, "w") as fd:
        fd.write("<RCC>\n")
        fd.write('  <qresource prefix="%s">\n' % prefix)
        for folder in folders:
            for dir, dirs, files in os.walk(folder):
                for file in files:
                    item = os.path.join(dir, file)
                    fd.write("    <file>%s</file>\n" % item)
        fd.write("  </qresource>\n")
        fd.write("</RCC>\n")

def usage():
    print("Usage: %s debug|release" % sys.argv[0])

def main():
    if len(sys.argv) != 2:
        usage()
        sys.exit(1)
    if sys.argv[1] == "debug":
        folders = ["webapp/src", "webapp/style"]
    elif sys.argv[1] == "release":
        folders = ["webapp/pub", "webapp/style"]
    else:
        usage()
        sys.exit(1)

    prefix="/"
    output = "webapp.qrc"
    generate(prefix, folders, output)

if __name__ == "__main__":
    main()
