// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef SERVICE_AUTO_START_H_
#define SERVICE_AUTO_START_H_

#include <QString>

namespace netease {

// Get auto startup status.
bool GetAutoStart();

// Enable or disable auto-start.
bool SetAutoStart(bool enable);

// Setup auto-start options. Also enables auto startup.
// |param| is passed to process startup params.
// e.g. if param = "foo", then "--orca-startup=foo" shall be appended to
// startup params.
// Returns true if succeeded, or false if failed.
void SetAutoStartOption(const QString& param);

}  // namespace netease

#endif  // SERVICE_AUTO_START_H_
