// Copyright (c) 2015 LiuLang. All rights reserved.
// Use of this source is governed by General Public License that can be found
// in the LICENSE file.

#ifndef SERVICE_BACKEND_DATABASE_WORKER_H_
#define SERVICE_BACKEND_DATABASE_WORKER_H_

#include <sqlite3.h>
#include <QObject>
#include <QVariantList>

namespace netease {

class DatabaseWorker : public QObject {
 Q_OBJECT

 public:
  explicit DatabaseWorker(QObject* parent = nullptr);

  // Commit changes and close database connection.
  ~DatabaseWorker() override;

  // Open a new db connection.
  bool open(const QString& db_file);

  QVariantList exec(const QStringList& statements, bool* ok);
  void execTransaction(const QString& statement, bool* ok);
  QVariantList rawExec(const QString& statements, bool* ok);

  void commit();
  sqlite3* db() { return db_; }

 private:
  void bindCollate();
  sqlite3* db_ = nullptr;
};

}  // namespace netease

#endif  // SERVICE_BACKEND_DATABASE_WORKER_H_
