// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef SERVICE_BACKEND_ZIP_WRAPPER_H_
#define SERVICE_BACKEND_ZIP_WRAPPER_H_

#include <QList>
#include <QString>

namespace netease {
namespace backend {

// Compress |src_file| to |dest_file|.
bool Zip(const QString& dest_file, const QString& src_file);

// Add |file_list| into |dest_file| zip file.
// If |dest_file| exists, remove it first.
// Folder names of |file_list| is striped.
bool Zip(const QString& dest_file, const QStringList& file_list);

}  // namespace backend
}  // namespace netease

#endif  // SERVICE_BACKEND_ZIP_WRAPPER_H_
