// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef SERVICE_DBUS_MANAGER_H_
#define SERVICE_DBUS_MANAGER_H_

#include <QObject>

class NetworkManagerInterface;
namespace netease {

class MprisAdapter;

// Check whether another instance of program is running.
// If it is running, raise its main window.
bool IsApplicationRunning();

// Notify player instance to play local music file.
bool NotifyPlayingLocalFile(const QString& filepath);

class DBusManager : public QObject {
  Q_OBJECT

 public:
  // Register Mpris dbus interface.
  explicit DBusManager(QObject* parent = nullptr);

  bool isOnline();

  void unRegister();

 signals:
  void connectivityChanged(bool is_online);

 private:
  MprisAdapter* mpris_adapter_obj_ = nullptr;
  NetworkManagerInterface* nm_iface_ = nullptr;

 private slots:
  void handleNMStateChanged(uint state);
};

}  // namespace netease

#endif  // SERVICE_DBUS_MANAGER_H_