// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef SERVICE_DEFAULT_CLIENT_H_
#define SERVICE_DEFAULT_CLIENT_H_

#include <QObject>

namespace netease {

// DefaultClient is used to register/unregister current application as the
// default music program in current desktop environment.

// Check if current application is the default music client.
bool IsDefaultClient();

// Register/unregister as the default music client.
// Note that this method always returns true.
bool SetDefaultClient(bool is_default);

}  // namespace netease

#endif  // SERVICE_DEFAULT_CLIENT_H_
