// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef SERVICE_PROCESS_MANAGER_H_
#define SERVICE_PROCESS_MANAGER_H_

#include <QObject>

namespace netease {

// Restart self if needed.
void DoRestart();

class ProcessManager : public QObject {
  Q_OBJECT

 public:
  explicit ProcessManager(QObject* parent = nullptr);
  ~ProcessManager() override;

 public slots:
  // Clear process resources and exit.
  void exit();

  // Clear process resources and restart self.
  // Note that
  void restart(const QStringList& arguments);

 private:
  // Set this flag to true when exit() is called at the first time.
  bool is_quited_;
};

}  // namespace netease

#endif  // SERVICE_PROCESS_MANAGER_H_
