// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef SERVICE_SETTINGS_MANAGER_H_
#define SERVICE_SETTINGS_MANAGER_H_

#include <QObject>
#include <QVariant>
class QSettings;

namespace netease {

QVariant SettingsGetDefaultValue(const QString& group_name, const QString& key);

// Get settings with |group_name| and |key|.
// If it is not found, returns its value in |default_settings_|.
QVariant SettingsGetValue(const QString& group_name, const QString& key);

// Update settings in |group_name| with |key| -> |value| pair.
void SettingsSetValue(const QString& group_name,
                      const QString& key,
                      const QVariant& value);

}  // namespace netease

#endif  // SERVICE_SETTINGS_MANAGER_H_
