// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef SERVICE_SYSTEM_TRAY_ICON_H_
#define SERVICE_SYSTEM_TRAY_ICON_H_

#include <QSystemTrayIcon>
class QMenu;

namespace netease {

// Displays a tray icon at system tray.
class SystemTrayIcon : public QSystemTrayIcon {
  Q_OBJECT

 public:
  explicit SystemTrayIcon(QObject* parent = nullptr);
  ~SystemTrayIcon() override;

 signals:
  void onClick();

  void onRightClick();

 private:
  void initConnections();
  QMenu* context_menu_ = nullptr;

 private slots:
  // Handles click and right click signal on system tray icon.
  void handleTrayActivated(ActivationReason reason);
};

}  // namespace netease

#endif  // SERVICE_SYSTEM_TRAY_ICON_H_
