// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef SERVICE_THREAD_MANAGER_H_
#define SERVICE_THREAD_MANAGER_H_

#include <QObject>
class QThread;

namespace netease {

class ThreadManager : public QObject {
  Q_OBJECT

 public:
  explicit ThreadManager(QObject* parent = nullptr);

  // Destructor background threads after stopping all workers running in
  // these threads.
  ~ThreadManager() override;

  // This thread is used by DownloadManager.
  QThread* album_cover_cache_thread = nullptr;

  QThread* download_manager_thread = nullptr;

  QThread* fs_watcher_thread = nullptr;

  // This thread is used by DBManager, MusicPlayerCache.
  QThread* media_player_cache_thread = nullptr;

  // Used by AlbumCoverCache, StorageManager.
  QThread* resources_manager_thread = nullptr;
  
  // Thread used by StorageManager
  QThread* storage_thread = nullptr;
  
  // Thread used by LocalMusicManager
  QThread* local_music_thread = nullptr;
};

}  // namespace netease

#endif  // SERVICE_THREAD_MANAGER_H_