// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#include "service/url_manager.h"

namespace netease {

UrlManager::UrlManager(QObject* parent)
    : QObject(parent),
      urls_() {
  this->setObjectName("url_manager");
}

void UrlManager::initUrls(const QVariantMap& url_info) {
  for (const QString& key : url_info.keys()) {
    const QVariant default_value("");
    const QString value = url_info.value(key, default_value).toString();
    urls_.insert(key, value);
  }
}

QString UrlManager::url(const QString& name) const {
  return urls_.value(name, QString());
}

}  // namespace netease
