 // Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef SERVICE_URL_MANAGER_H_
#define SERVICE_URL_MANAGER_H_

#include <QHash>
#include <QObject>
#include <QVariant>

namespace netease {

// Manage default request urls.
class UrlManager : public QObject {
  Q_OBJECT

 public:
  explicit UrlManager(QObject* parent = nullptr);

  void initUrls(const QVariantMap& url_info);

  // Get url with |name|.
  QString url(const QString& name) const;

 private:
  QHash<QString, QString> urls_;
};

}  // namespace netease

#endif  // SERVICE_URL_MANAGER_H_