/*
 * Copyright (C) 2017 ~ 2017 Deepin Technology Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <QCoreApplication>
#include <QDebug>

#include "third_party/CuteLogger/CuteLogger/ConsoleAppender.h"
#include "third_party/CuteLogger/CuteLogger/Logger.h"
#include "third_party/CuteLogger/CuteLogger/FileAppender.h"

int main(int argc, char** argv) {
  QCoreApplication app(argc, argv);

  const char kLogFile[] = "/tmp/demo2.json";
  FileAppender* file_appender = new FileAppender(kLogFile);
  file_appender->setDetailsLevel(Logger::Debug);
  logger->registerAppender(file_appender);

  qDebug() << "args:" << app.arguments();
}