/*
 * Copyright (C) 2017 ~ 2017 Deepin Technology Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <QApplication>

#include <QColorDialog>
#include <QtCore/QLibraryInfo>
#include <QtCore/QDir>
#include <QtCore/QTranslator>

int main(int argc, char** argv) {
  QApplication app(argc, argv);

  // Load system translations resources.
  QTranslator* sys_translator = new QTranslator();
  const QString qt_trans = QLibraryInfo::location(
      QLibraryInfo::TranslationsPath);
  if (sys_translator->load(QDir(qt_trans).filePath("qt_zh_CN.qm"))) {
    app.installTranslator(sys_translator);
  }

  QColorDialog dialog;
  dialog.show();

  return app.exec();
}