/*
 * Copyright (C) 2017 ~ 2017 Deepin Technology Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <QApplication>
#include <QDebug>

#include "service/backend/filesystem_watcher.h"

int main(int argc, char** argv) {
  QApplication app(argc, argv);

  netease::FilesystemWatcher watcher;
  QObject::connect(&watcher, &netease::FilesystemWatcher::fileAdded,
                   [](const QString& root_dir, const QString& filepath) {
    qDebug() << "File added:" << root_dir << filepath;
  });
  QObject::connect(&watcher, &netease::FilesystemWatcher::folderAdded,
                   [](const QString& root_dir, const QString& dir) {
    qDebug() << "Folder added:" << root_dir << dir;
  });
  QObject::connect(&watcher, &netease::FilesystemWatcher::fileDeleted,
                   [](const QString& root_dir, const QString& filepath) {
    qDebug() << "File deleted:" << root_dir << filepath;
  });
  QObject::connect(&watcher, &netease::FilesystemWatcher::folderDeleted,
                   [](const QString& root_dir, const QString& dir) {
    qDebug() << "Folder deleted:" << root_dir << dir;
  });
  if (argc > 1) {
    watcher.watchFolder(argv[1], true);
    watcher.watchFolder(argv[1], true);
  }

  return app.exec();
}