/*
 * Copyright (C) 2017 ~ 2017 Deepin Technology Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <QCoreApplication>
#include <QDebug>

#include "service/backend/media_metadata_reader.h"

int main(int argc, char** argv) {
  QCoreApplication app(argc, argv);

  const QString msg = "Hello{, world";
  const QString cipher = netease::EncryptMediaComment(msg);
  qDebug() << "cipher:" << cipher;
  const QString decrypted_msg = netease::DecryptMediaComment(cipher);
  qDebug() << "msg:" << decrypted_msg;

  for (int i = 1; i < argc; ++i) {
    netease::AudioMetadata metadata = netease::ReadAudioInfo(argv[i]);
    qDebug() << "i: " << argv[i] << metadata.title
             << metadata.album << metadata.artist
             << "duration:" <<metadata.duration
             << ", bitrate:" << metadata.bitrate
             << ", comment:" << metadata.comment;
    if (!metadata.comment.isEmpty()) {
      qDebug() << "comment:" << netease::DecryptMediaComment(metadata.comment);
    }
  }

  return 0;
}