/*
 * Copyright (C) 2017 ~ 2017 Deepin Technology Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CLOUD_MUSIC_TESTS_MOVE_RESIZE_EVENT_FILTER_H
#define CLOUD_MUSIC_TESTS_MOVE_RESIZE_EVENT_FILTER_H

#include <QAbstractNativeEventFilter>

class QWidget;

class MoveResizeEventFilter : public QAbstractNativeEventFilter {
 public:
  MoveResizeEventFilter();

  bool nativeEventFilter(const QByteArray& eventType, void* message,
                         long* result) override;

  enum class Action {
    Move,
    ResizeRight,
    ResizeBottomRight,
    Invalid,
  };

  void startAction(QWidget* widget, Action action);

 private:
  inline void uninstallFilter();

  QWidget* target_ = nullptr;
  Action action_ = Action::Invalid;
  int start_x_ = 0;
  int start_y_ = 0;
};

#endif  // CLOUD_MUSIC_TESTS_MOVE_RESIZE_EVENT_FILTER_H
