/*
 * Copyright (C) 2017 ~ 2017 Deepin Technology Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <QCoreApplication>
#include <QDebug>
#include <QtDBus/QtDBus>

const char kServiceName[] = "org.mpris.MediaPlayer2.rhythmbox";
const char kServicePath[] = "/org/mpris/MediaPlayer2";
const char kRootInterface[] = "org.mpris.MediaPlayer2";
const char kPlayerInterface[] = "org.mpris.MediaPlayer2.Player";

bool IsAppRunning() {
  QDBusInterface interface(kServiceName, kServicePath, kRootInterface,
                           QDBusConnection::sessionBus());
  if (interface.isValid()) {
    interface.asyncCall("Raise");
    return true;
  }
  return false;
}

int main(int argc, char* argv[]) {
  QCoreApplication app(argc, argv);

//  MprisController controller(kServiceName, QDBusConnection::sessionBus());
//  controller.raise();
//  qDebug() << "controller isValid(): " << controller.isValid();
  qDebug() << IsAppRunning();

  return app.exec();
}