// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef UI_MODELS_PLAYLIST_MODEL_H_
#define UI_MODELS_PLAYLIST_MODEL_H_

#include <QAbstractListModel>
class QPixmap;

namespace netease {

struct SongInfo;

class PlaylistModel : public QAbstractListModel {
  Q_OBJECT

 public:
  explicit PlaylistModel(QObject* parent = nullptr);
  ~PlaylistModel();

  void addSongs(const QList<SongInfo>& song_list);
  // Remove all songs in playlist.
  void clearPlaylist();
  // Remove songs from playlist.
  void deleteSongs(const QStringList& play_id_list);
  bool isEmpty() const;
  void setCurrentRow(int row);
  void setPlayState(bool is_playing);
  // Get song info at |row|.
  SongInfo getSongInfo(int row);
  int rowOf(const QString& play_id) const;
  int currentPlayRow() const;

  QVariant data(const QModelIndex& index, int role) const Q_DECL_OVERRIDE;
  Qt::ItemFlags flags(const QModelIndex& index) const Q_DECL_OVERRIDE;
  int rowCount(const QModelIndex& parent) const Q_DECL_OVERRIDE;

 private:
  QList<SongInfo> playlist_;
  int current_play_row_;
  bool is_playing_;
};

}  // namespace netease

#endif  // UI_MODELS_PLAYLIST_MODEL_H_
