// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#include "song_info.h"

namespace netease {

QJsonObject &operator <<(QJsonObject& obj, const SongInfo& info) {
  obj.insert("album", QJsonValue(info.album));
  obj.insert("alias", QJsonValue(info.alias));
  obj.insert("artist", QJsonValue(info.artist));
  obj.insert("cloud", QJsonValue(info.cloud));
  obj.insert("from", QJsonValue(info.from));
  obj.insert("mv", QJsonValue(info.mv));
  obj.insert("play_id", QJsonValue(info.play_id));
  obj.insert("program", QJsonValue(info.program));
  obj.insert("title", QJsonValue(info.title));
  obj.insert("track_id", QJsonValue(info.track_id));
  obj.insert("play_state", QJsonValue(info.play_state));

  return obj;
}

const QJsonObject &operator >>(QJsonObject& obj, SongInfo& info) {
  info.album = obj.value("album").toString();
  info.alias = obj.value("alias").toString();
  info.artist = obj.value("artist").toString();
  info.cloud = obj.value("cloud").toInt();
  info.from = obj.value("from").toString();
  info.mv = obj.value("mv").toString();
  info.play_id = obj.value("play_id").toString();
  info.program = obj.value("program").toInt();
  info.title = obj.value("title").toString();
  info.track_id = obj.value("track_id").toInt();
  info.play_state = SongPlayState(obj.value("play_state").toInt());

  return obj;
}

QDebug &operator <<(QDebug& debug, const SongInfo& info) {
  debug << "["
        << "album:" << info.album
        << ", alias:" << info.alias
        << ", artist:" << info.artist
        << ", cloud:" << info.cloud
        << ", from:" << info.from
        << ", mv:" << info.mv
        << ", play_id:" << info.play_id
        << ", program:" << info.program
        << ", title:" << info.title
        << ", track_id:" << info.track_id
        << "]";
  return debug;
}

}
