// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef UI_MODELS_SONG_INFO_H_
#define UI_MODELS_SONG_INFO_H_

#include <QString>
#include <QList>
#include <QJsonArray>
#include <QJsonObject>
#include <QDebug>

namespace netease {

enum SongPlayState {
  Playing,
  Paused,
  Stoped
};

struct SongInfo {
  // Album name.
  QString album;

  // Song name alias, might be empty.
  QString alias;

  // Artist name.
  QString artist;

  // TODO (xushaohua): Add comments.
  int cloud = 0;

  // Name of playlist.
  QString from;

  // Might be empty.
  QString mv;

  // Like "27949864_1_2255008"
  QString play_id;

  // Program name.
  int program = 0;

  // Song name.
  QString title;

  int track_id = 0;

  // For delegate
  SongPlayState play_state;
};

QJsonObject &operator <<(QJsonObject& obj, const SongInfo& info);
const QJsonObject &operator >>(QJsonObject& obj, SongInfo& info);
QDebug &operator <<(QDebug& debug, const SongInfo& info);

}  // namespace netease

#endif  // UI_MODELS_SONG_INFO_H_

