// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef UI_VIEWS_LRC_PLAIN_FRAME_H_
#define UI_VIEWS_LRC_PLAIN_FRAME_H_

#include <QLabel>
class QPaintEvent;
class QResizeEvent;

#include "service/lrc_manager.h"

namespace netease {

// Render lrc content with basic style, no color.
class LrcPlainFrame : public QLabel {
  Q_OBJECT

 public:
  explicit LrcPlainFrame(QWidget* parent = nullptr);

 protected:
  void paintEvent(QPaintEvent* event) override;

  // Override resizeEvent() to store window size explicitly.
  void resizeEvent(QResizeEvent *event) override;

 private:
  void initConnections();

  QFont lrc_font_;
  LrcManager::LrcElement lrc_element_;

  int offset_x_;
  bool scroll_lrc_;

  // this->size() returns incorrect value in handleMediaPositionChanged().
  // So use |window_size_| to store real window size.
  QSize window_size_;

 private slots:
  void handlePositionChanged(qint64 position);
};

}  // namespace netease

#endif  // UI_VIEWS_LRC_PLAIN_FRAME_H_
