// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#include "ui/views/mini_player_lrc.h"

#include <QDebug>
#include <QEvent>
#include <QLabel>
#include <QVBoxLayout>

#include "ui/views/lrc_plain_frame.h"
#include "ui/views/mini_player_consts.h"

namespace netease {

MiniPlayerLrc::MiniPlayerLrc(QWidget* parent) : QFrame(parent) {
  initUI();
}

void MiniPlayerLrc::enterEvent(QEvent* event) {
  emit mouseEntered();
  QFrame::enterEvent(event);
}

void MiniPlayerLrc::initUI() {
  lrc_label_ = new LrcPlainFrame(this);

  QVBoxLayout* layout = new QVBoxLayout();
  layout->setContentsMargins(0, 0, 0, 0);
  layout->setSpacing(0);
  layout->addWidget(lrc_label_);
  this->setLayout(layout);

  // Add margins at each side.
  this->setContentsMargins(5, 0, 2, 0);
  this->setAttribute(Qt::WA_TranslucentBackground);
}

}  // namespace netease
