// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef UI_VIEWS_MINI_PLAYER_TITLE_H_
#define UI_VIEWS_MINI_PLAYER_TITLE_H_

#include <QFrame>
class QEvent;
class QLabel;

namespace netease {

class MiniPlayerTitle : public QFrame {
  Q_OBJECT

 public:
  explicit MiniPlayerTitle(QWidget* parent = nullptr);

  void updateContent(const QString& title, const QString& artist);

 signals:
  void mouseEntered();

 protected:
  void enterEvent(QEvent* event) override;

  // Override resizeEvent() to get actual size of current widget.
  void resizeEvent(QResizeEvent* event) override;

 private:
  void initUI();

  QLabel* title_label_;
  QLabel* artist_label_;

  QSize widget_size_;

 private slots:
  void updateStyle();
};

}  // namespace netease

#endif  // UI_VIEWS_MINI_PLAYER_TITLE_H_
