// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#include "ui/views/widgets/draggable_area.h"

#include <QDebug>
#include <QMouseEvent>

#include "ui/utils/xutil.h"

namespace netease {

DraggableArea::DraggableArea(QWidget* container, QWidget* parent)
    : QFrame(parent),
      container_(container) {
  Q_ASSERT(container_ != nullptr);
  setObjectName("draggable_area");
}

void DraggableArea::leaveEvent(QEvent* event) {
  QFrame::leaveEvent(event);
  emit mouseLeaved();
}

void DraggableArea::mousePressEvent(QMouseEvent* event) {
  if (event->button() == Qt::LeftButton) {
    utils::MoveWindow(this->container_);
  }
  QFrame::mousePressEvent(event);
}

}  // namespace netease
