// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef UI_VIEWS_WIDGETS_DRAGGABLE_AREA_H_
#define UI_VIEWS_WIDGETS_DRAGGABLE_AREA_H_

#include <QFrame>
class QEvent;
class QMouseEvent;

namespace netease {

// DraggableArea provides a moving handler of a container.
// This is used when application window is not decorated by window manager.
class DraggableArea : public QFrame {
  Q_OBJECT

 public:
  explicit DraggableArea(QWidget* container, QWidget* parent = nullptr);

 signals:
  void mouseLeaved();

 public slots:
  void leaveEvent(QEvent* event) override;

  // Override these methods to change window type when mouse pressed.
  void mousePressEvent(QMouseEvent* event) override;

 private:
  // An ancestor widget, mostly a QFrame or a QWindow
  QWidget* container_;
};

}  // namespace netease

#endif  // UI_VIEWS_WIDGETS_DRAGGABLE_AREA_H_
