// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#include "ui/views/widgets/flat_button.h"

#include "ui/utils/xutil.h"

namespace netease {

FlatButton::FlatButton(QWidget* parent) : QPushButton(parent) {
  setFlat(true);
}

void FlatButton::enterEvent(QEvent* event) {
  utils::SetCursorShape(this, XC_hand1);
  QPushButton::enterEvent(event);
}

void FlatButton::leaveEvent(QEvent* event) {
  utils::ResetCursorShape(this);
  QPushButton::leaveEvent(event);
}

}  // namespace netease