// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by Commercial License that can be found
// in the LICENSE file.

#ifndef UI_VIEWS_WIDGETS_POPUP_MENU_H_
#define UI_VIEWS_WIDGETS_POPUP_MENU_H_

#include <QMenu>
class QAction;
class QMouseEvent;

namespace netease {

// Defines a qmenu with specific styles.
// Used in PopupMenuManager.
class PopupMenu : public QMenu {
  Q_OBJECT

 public:
  explicit PopupMenu(QWidget* parent = nullptr);

  // Add a new action with |check_icon|.
  QAction* createAction(const QPixmap& icon, const QString& text,
                     const QPixmap& check_icon);

 private:
  void initConnections();

 private slots:
  void updateSkin();
};

}  // namespace netease

#endif  // UI_VIEWS_WIDGETS_POPUP_MENU_H_
