// Copyright (c) 2015 Deepin Ltd. All rights reserved.
// Use of this source is governed by General Public License that can be found
// in the LICENSE file.

#include "ui/views/widgets/popup_menu_item.h"

#include <QDebug>
#include <QEvent>
#include <QHBoxLayout>
#include <QLabel>
#include <QMouseEvent>
#include <QPaintEvent>

#include "application.h"
#include "base/file_util.h"
#include "service/skin_manager.h"

namespace netease {

namespace {

const char kStyleSheetFile[] = ":/styles/popup-menu.css";

//const char kNormalBackground[] = "SKIN_ROOT/menu/item.png";
//const char kHoverBackground[] = "SKIN_ROOT/menu/hover.png";

}  // namespace

PopupMenuItem::PopupMenuItem(const QPixmap& icon, const QString& text,
                             const QPixmap& check_icon, QWidget* parent)
    : QFrame(parent) {

  background_label_ = new QLabel(this);

  QLabel* icon_label = new QLabel();
  icon_label->setPixmap(icon);
  icon_label->setObjectName("icon-label");
  icon_label->setAttribute(Qt::WA_TranslucentBackground);

  QLabel* text_label = new QLabel(text);
  text_label->setObjectName("text-label");
  text_label->setAttribute(Qt::WA_TranslucentBackground);

  QLabel* check_icon_label = new QLabel();
  check_icon_label->setPixmap(check_icon);
  check_icon_label->setObjectName("check-icon-label");
  check_icon_label->setAttribute(Qt::WA_TranslucentBackground);

  QHBoxLayout* hbox = new QHBoxLayout();
  hbox->setContentsMargins(0, 0, 0, 0);
  hbox->setSpacing(0);
  hbox->addWidget(icon_label);
  hbox->addWidget(text_label);
  hbox->addWidget(check_icon_label);

  this->setObjectName("label-container");
  this->setContentsMargins(0, 0, 0, 0);
  this->setLayout(hbox);
  this->setAttribute(Qt::WA_TranslucentBackground);

  this->setStyleSheet(app->skin_manager->formatStyleFile(kStyleSheetFile));
}

}  // namespace netease
